package com.engine.shkjsecond.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import net.coobird.thumbnailator.Thumbnails;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.util.IOUtils;
import weaver.file.ImageFileManager;
import weaver.general.GCONST;
import weaver.general.Util;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.Base64;

/**
 * @Author liang.cheng
 * @Date 2025/2/17 14:56
 * @Description:
 * @Version 1.0
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class PersonnelResumePo {

    private Integer id;
    private String lastName;
    private String sex;
    private String birthday;
    private String resourceImageId;

    private String certificatenum;
    private String residence;
    private String politicsStatus;
    private String nation;
    private String nativePlace;

    private String height;
    private String weight;
    private String maritalStatus;

    private String companyStartDate;
    private String jobTitle;
    private String department;
    private String educationlevel;
    private String graduateSchool;
    private String major;
    private String jobcall;
    private String address;
    private String mobile;
    private String email;

    private String emergencyContact;
    private String relationship;
    private String eContactMobile;

    public String getSex() {
        if ("1".equals(sex)) {
            return "女";
        }
        return "男";
    }

    public String getImage() {
        if (StringUtils.isBlank(resourceImageId)) {
            return "";
        }
        ImageFileManager manager = new ImageFileManager();
        manager.getImageFileInfoById(Util.getIntValue(resourceImageId));
        InputStream inputStream = manager.getInputStream();
        String imageStr = "";
        try {
            String outPutPath = GCONST.getRootPath() + "hrm" + File.separator + "import" + File.separator + "template" + File.separator
                    + manager.getImageFileName();
            File f = new File(outPutPath);
            if (!f.exists()) {
                String substring = outPutPath.substring(0, outPutPath.lastIndexOf(File.separator));
                File file = new File(substring);
                if (file.mkdirs()) {
                    boolean newFile = f.createNewFile();
                    if (!newFile) {
                        throw new IOException(outPutPath + "文件创建失败");
                    }
                }
            }
            Thumbnails.of(inputStream).forceSize(100, 120).toFile(f);
            InputStream fileInputStream = Files.newInputStream(f.toPath());
            imageStr = "data:image/" + manager.getImageFileType() + ";base64," + Base64.getEncoder().encodeToString(IOUtils.toByteArray(fileInputStream));
            // 删除文件
            f.delete();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return imageStr;
    }


    public String getMarriage() {
        if (StringUtils.isBlank(maritalStatus)) {
            return "未婚";
        }
        switch (maritalStatus) {
            case "1":
                return "已婚";
            case "2":
                return "离异";
            case "0":
            default:
                return "未婚";
        }
    }
}
